#!/bin/bash

if [ $# -ne 1 ]; then
    echo "Использование: $0 /dev/sdX"
    echo "Где /dev/sdX - ваша флешка"
    exit 1
fi

DEVICE=$1

if [ ! -b "$DEVICE" ]; then
    echo "[-] Устройство $DEVICE не найдено"
    exit 1
fi

echo "[*] Создаю автономную загрузочную флешку на $DEVICE"
echo "[!] ВСЕ ДАННЫЕ БУДУТ УДАЛЕНЫ!"
read -p "Продолжить? (y/N): " -n 1 -r
echo
if [[ ! $REPLY =~ ^[Yy]$ ]]; then
    exit 1
fi

echo "[*] Собираю образ ОС..."
make clean
make os.bin

if [ ! -f "os.bin" ]; then
    echo "[-] Ошибка сборки os.bin"
    exit 1
fi

echo "[*] Записываю образ на флешку..."
sudo dd if=os.bin of=$DEVICE bs=512 status=progress

echo "[*] Синхронизирую данные..."
sudo sync

echo "[+] Автономная загрузочная флешка готова!"
echo "[*] Флешка загрузится сама и начнет дамп памяти"
echo "[*] Просто вставьте её в целевую систему и перезагрузитесь" 