# YACBA - Быстрый старт

## Что это?
Автономная флешка с собственной ОС для cold-boot атак.
Вставил флешку → перезагрузился → система дампит память.

## Сборка

**macOS/Windows (Docker):**
```bash
./docker-build.sh
```

**Linux:**
```bash
./build.sh
```

## Создание флешки

```bash
sudo ./create_boot_usb.sh /dev/sdX  # замените X на вашу флешку
```

## Использование

1. Выключить целевую систему (выдернуть питание)
2. Вставить флешку
3. Включить систему
4. Флешка загрузится и начнет дамп автоматически
5. Дождаться завершения (прогресс на экране)

## Что дампится

- Память с адресов 1MB, 16MB, 256MB
- Поиск паттернов: пароли, логины, ключи
- Данные сохраняются в буфер по адресу 0x200000

⚠️ **Только для образования и своих систем!** 